/*
 *                        Lamma Regione Toscana
 *
 * Author   : Graziano Giuliani
 * Project  : WW3 forecast system
 * Date     : Fri May 30 15:43:52 CEST 2003
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef __grib_h_included__
#define __grib_h_included__

void open_grib(char *filename, int *istat, int fsize);

void read_record(int *istat);

void close_grib( );

void print_pds_hex( );
void print_pds_dec( );
void print_gds_hex( );
void print_gds_dec( );
void print_bms_hex( );
void print_bms_dec( );

void print_grid_size( );
void print_variable_name( );
void print_variable_desc( );
void print_datetime( );
void print_grid_info( );
void print_level( );
void print_data( );

int get_pds_value(int *index);

int is_gds_present( );
int get_gds_value(int *index);

int is_bms_present( );
int get_bms_value(int *index);

void get_grid_size(long *nx, long *ny, long *nxny);
void get_variable_name(char *vname, int vsize);
void get_variable_desc(char *vdesc, int vsize);

int is_level_pressure( );
int is_level_z( );
int is_surface( );
int is_mean_sea_level( );

void get_level_value(float *val);
void get_level_desc(char *ldesc, int vsize);
void get_reftime(char *stime, int vsize);
void get_forecast_time(int *rincr);

void get_datetime(int *year, int *month, int *day, int *hour, int *minute);

void get_latlon_grid_info(float *minlat, float *maxlat, float *dlat,
                          float *minlon, float *maxlon, float *dlon);

void get_data(int *inx, int *iny, float *data);

void cname(char *src, char *dest, int maxlen);

#endif
